/* Copyright (c) 2006-2014 Polybus Systems Corp., Westford, MA, USA */

/* All rights reserved. */

/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met: */

/* * Redistributions of source code must retain the above copyright notice, this */
/* list of conditions and the following disclaimer. */
/* * Redistributions in binary form must reproduce the above copyright notice, */
/* this list of conditions and the following disclaimer in the documentation */
/* and/or other materials provided with the distribution. */
/* * Neither the name of the Polybus Systems Corp nor the names of its contributors */
/* may be used to endorse or promote products derived from this software */
/* without specific prior written permission. */

/* THIS SOFTWARE IS PROVIDED BY POLYBUS AND CONTRIBUTORS ''AS IS'' AND ANY */
/* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE */
/* DISCLAIMED. IN NO EVENT SHALL POLYBUS OR CONTRIBUTORS BE LIABLE FOR ANY */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES */
/* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON */
/* ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT */
/* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

#include "sys_basher.h"
#include <sensors/sensors.h>

Boolean getTemps(long *num_values,char temp_names[64][64],double feature_value[])
{
  int i=0,j=0;
  long cnt=0;
  FILE *file=0;
  char *indx=0;
  char label[256];
  double value=0;
  static char *config[] = {"/etc/sensors.conf","/usr/local/etc/sensors.conf","/etc/sensors3.conf",0L};
  static const sensors_chip_name *chip_name=0;
  const sensors_feature *feature_data=0;
  Boolean found=FALSE,same_sensor=FALSE;
  *num_values = 0;
  i = 0;
  while((config[i] != NULL) && (file == NULL))
    {
      file = fopen (config[i], "r");
      i++;
    }
  if(file != NULL)
    {
      if(sensors_init(file) != 0L)
	{
	  fclose(file);
	  return(0);
	}
    }
  else 
    {
      return(0);
    }
  fclose(file);

  i = 0;
  chip_name = sensors_get_detected_chips (NULL,&i);
  while(chip_name)
    {
      
      j = 0;
      if(chip_name)
	{
	  feature_data = sensors_get_features (chip_name, &j);
	  while (feature_data != NULL) 
	    {
	      indx = sensors_get_label(chip_name, feature_data);
	      if(indx != 0)
		{
		  cpyUpCase(label,indx);
		  if((findSubString(label,"TEMP")) || (findSubString(label,"CORE")) || (findSubString(label,"VOLT")) || (findSubString(label,"FAN")))
		    {
		      if((!findSubString(label,"OVER")) && 
			 (!findSubString(label,"HYST")) &&
			 (!findSubString(label,"ALARM"))
			 )
			{
			  same_sensor = FALSE;
			  if(cnt > 0)
			    {
			      same_sensor = (0 == strcmp(label,temp_names[cnt-1]));
			    }
			  if(!same_sensor) 
			    {
			      strncpy(temp_names[cnt],label,32);
			      if(0 == sensors_get_value(chip_name,feature_data->first_subfeature,&value))
				{
				  feature_value[cnt] = value;
				  cnt++;
				  if(cnt == 64)
				    {
				      sensors_cleanup();
				      return(TRUE);
				    }
				  found = TRUE;
				}
			    }
			}
		    }
		  free(indx);
		}
	      feature_data = sensors_get_features (chip_name, &j);

	    }
	}
      chip_name = sensors_get_detected_chips (NULL,&i);
    }
  *num_values = cnt;
  sensors_cleanup();
  return(found);
}

